using System;
using System.Collections;
using UnityEngine;

namespace Experiment01
{
	public abstract class AndroidInjectorBase: MonoBehaviour {
	  private void Start() {
		  this.Light = gameObject.transform.Find("glow").gameObject;
	    if (this.Fingerprint == null || this.Fingerprint.Length == 0) {
	      this.CreateNewFingerprint();
	    }
	  }

	  private void CreateNewFingerprint() {
	    this.Fingerprint = new float[64];
	    for (int i = 0; i < this.Fingerprint.Length; i++) {
	      this.Fingerprint[i] = UnityEngine.Random.Range(-1f, 1f);
	    }
	    Debug.Log(string.Format("AT-Fingerprints ({0}) filled", this.Fingerprint.Length));
	  }
	  IEnumerator StartInfecting(LimbBehaviour limbBehaviour) {
      while (activated) {
        yield
        return new WaitForSeconds(1.0f);
        timer--;
        if (timer == 0) {
          PoisonSpreadBehaviour poisonSpreadBehaviour = limbBehaviour.gameObject.AddComponent(this.GetPoisonType()) as PoisonSpreadBehaviour;
	      poisonSpreadBehaviour.Limb = limbBehaviour;
	      poisonSpreadBehaviour.Fingerprint = this.Fingerprint;
		  this.SetActivated(false);
		  audioSource.PlayOneShot(clip2, 0.7F);
		  DestroyJoint();
        }
        yield
        return null;
      }
    }
	private void Use() {
         if (!base.enabled) {
            return;
         }
		 if (isStuck)
		 {
			 return;
		 }
         this.SetActivated(!this.activated);
      }

      // Token: 0x0600026C RID: 620 RVA: 0x0000C50E File Offset: 0x0000A70E
      private void SetActivated(bool activatedd) {
         this.activated = activatedd;
         this.Light.SetActive(activated);
      }
	  private void TryInfect(GameObject toinject) {
	    LimbBehaviour limbBehaviour;
		if(isStuck)
		{
			return;
		}
	    if (!toinject.TryGetComponent < LimbBehaviour > (out limbBehaviour)) {
	      return;
	    }
		if (!limbBehaviour.IsAndroid)
		{
			return;
		}
	    if (!limbBehaviour.GetComponent(this.GetPoisonType())) {
	      /*PoisonSpreadBehaviour poisonSpreadBehaviour = limbBehaviour.gameObject.AddComponent(this.GetPoisonType()) as PoisonSpreadBehaviour;
	      poisonSpreadBehaviour.Limb = limbBehaviour;
	      poisonSpreadBehaviour.Fingerprint = this.Fingerprint;*/
		  timer = 3;
		  audioSource.PlayOneShot(clip1, 0.7F);
		  CreateJoint(limbBehaviour.gameObject.GetComponent < Rigidbody2D > ());
		  StartCoroutine(StartInfecting(limbBehaviour));
	    }
	  }
	  private void OnCollisionEnter2D(Collision2D col) {
		  if(!activated)
		  {
			  return;
		  }
TryInfect(col.gameObject);
	  }
	  private void CreateJoint(Rigidbody2D phys) {
      if (this.joint) {
        UnityEngine.Object.Destroy(this.joint);
      }
      this.joint = base.gameObject.AddComponent < FixedJoint2D > ();
      this.joint.connectedBody = phys;
	  isStuck = true;
      //base.gameObject.layer = this.nocollisionLayer;
    }
	private void DestroyJoint() {
      //base.gameObject.layer = this.objectLayer;
      this.isStuck = false;
      if (this.joint) {
        UnityEngine.Object.Destroy(this.joint);
      }
    }
	  public abstract Type GetPoisonType();
	  [HideInInspector]
	  public float[] Fingerprint;
	  [SkipSerialisation]
       public GameObject Light;
	   bool activated = true;
	   public FixedJoint2D joint;
	   public bool isStuck = false;
	   public int timer = 3;
	   public AudioClip clip1;
	   public AudioClip clip2;
    public AudioSource audioSource;
	}
}