using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Experiment01 {

  //public class GunsDeployed : MonoBehaviour{}
  public class SmoothGrowth: MonoBehaviour {
    public void ScaleStart(float time,float scale) {
      StartCoroutine(ScaleOverTime(time,gameObject.transform.localScale * scale));
    }
    IEnumerator ScaleOverTime(float time, Vector3 destinationScale) {
      Vector3 originalScale = gameObject.transform.localScale;

      float currentTime = 0.0f;

      do {
        gameObject.transform.localScale = Vector3.Lerp(originalScale, destinationScale, currentTime / time);
        currentTime += Time.deltaTime;
        yield
        return null;
      } while (currentTime <= time);

      Destroy(this);
    }
  }
  class GiantizerPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 50f;
      }
    }

    public override void Start() {
      if (Limb.gameObject.name == "Head") {
        //Limb.gameObject.transform.parent.localScale *= 1.25f;
        Limb.gameObject.transform.parent.gameObject.AddComponent < SmoothGrowth > ().ScaleStart(1f,1.25f);
      }
    }

    public GiantizerPoison() {}
  }
class HeadInflationPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 50f;
      }
    }

    public override void Start() {
      if (Limb.gameObject.name == "Head") {
        Limb.gameObject.AddComponent < SmoothGrowth > ().ScaleStart(1f,1.25f);
      }
    }

    public HeadInflationPoison() {}
  }
  class StrengthInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (UltraStrengthPoison);
    }
  }
  class KnockoutInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (KnockoutPoison);
    }
  }
  class AcidInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (AcidPoison);
    }
  }
  class GiantizerInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (GiantizerPoison);
    }
  }
  class HeadInflator: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (HeadInflationPoison);
    }
  }
}