using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Experiment01 {
	public static class InjectorHelpers {
		public static void CreateRope(GameObject A,GameObject B,Color32 color,float distance)
		{
			DistanceJoint2D joint = A.AddComponent<DistanceJoint2D>();
                joint.maxDistanceOnly = true;
                joint.enableCollision = true;
                joint.distance = distance;
                joint.autoConfigureDistance = false;
                joint.breakForce = Mathf.Infinity;
                joint.breakTorque = Mathf.Infinity;
                joint.connectedBody = B.GetComponent<Rigidbody2D>();
				joint.anchor = new Vector2(0f, 0f);
                joint.connectedAnchor = new Vector2(0f,0f);
				EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
            energyWireBehaviour.WireColor = color;
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            energyWireBehaviour.WireWidth = 0.1f;
            energyWireBehaviour.typedJoint = joint;
		}
	  public static bool PoisonCanInfect(GameObject checkedthing,string keys,bool addifnot) {
		  DoNotAffect dndasd = checkedthing.GetComponent < DoNotAffect > () as DoNotAffect;
	    if (dndasd != null && dndasd.key == keys) {
	      return false;
	    }
		else
		{
			if(addifnot)
			{
			checkedthing.AddComponent < DoNotAffect > ().key = keys;
			}
			return true;
		}
	  }
	}
	public class DoNotAffect: MonoBehaviour {
		public string key = "";
	}
	class AndroidWaterproof: MonoBehaviour {
		void Start()
		{
			this.Limb = gameObject.GetComponent<LimbBehaviour>();
		}
		void FixedUpdate()
		{
			Limb.PhysicalBehaviour.Wetness = Mathf.Clamp(Limb.PhysicalBehaviour.Wetness,0f,0.2f);
		}
		[SkipSerialisation]
	public LimbBehaviour Limb;
	}
class HeadPopPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 8f;
      }
    }

    public override void Start() {
      if (Limb.gameObject.name == "Head" && InjectorHelpers.PoisonCanInfect(Limb.gameObject,"headpop",true)) {
        ModAPI.CreateParticleEffect("HugeZap",Limb.gameObject.transform.position);
		Limb.BreakingThreshold -= 340282346600000000000000000000000000f;
			Limb.IsLethalToBreak = true;
			Limb.gameObject.GetComponent<Rigidbody2D>().AddForce(transform.up* 50f,ForceMode2D.Impulse);
      }
    }

    public HeadPopPoison() {}
  }
  class WaterproofPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 30f;
      }
    }

    public override void Start() {
		if (Limb.gameObject.GetComponent<AndroidWaterproof>() == null) {
	      Limb.gameObject.AddComponent<AndroidWaterproof>();
	    }
    }

    public WaterproofPoison() {}
  }
  class HeadPopInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (HeadPopPoison);
    }
  }
  class WaterproofInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (WaterproofPoison);
    }
  }
  class PinkInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (AndroidPinkPoison);
    }
  }
  public class AndroidPinkPoison : PoisonSpreadBehaviour
{
	// Token: 0x1700007E RID: 126
	// (get) Token: 0x0600062C RID: 1580 RVA: 0x0002117A File Offset: 0x0001F37A
	public override float SpreadSpeed
	{
		get
		{
			return 10f;
		}
	}

	// Token: 0x0600062D RID: 1581 RVA: 0x00021181 File Offset: 0x0001F381
	public override void Start()
	{
		this.WhatTheFuck();
	}

	// Token: 0x0600062E RID: 1582 RVA: 0x0002118C File Offset: 0x0001F38C
	private void WhatTheFuck()
	{
		CirculationBehaviour circulationBehaviour = this.Limb.CirculationBehaviour;
		SkinMaterialHandler skinMaterialHandler = this.Limb.SkinMaterialHandler;
		PhysicalBehaviour physicalBehaviour = this.Limb.PhysicalBehaviour;
		this.Limb.BalanceMuscleMovement += base.GetFingerprintValue() * 0.5f;
		this.Limb.BloodMuscleStrengthRatio += base.GetFingerprintValue() * 0.5f;
		this.Limb.DoBalanceJerk ^= (base.GetFingerprintValue() > 0.7f);
		this.Limb.DoStumble ^= (base.GetFingerprintValue() > 0.7f);
		this.Limb.Numbness += base.GetFingerprintValue();
		this.Limb.ShotDamageMultiplier += base.GetFingerprintValue() * 5f;
		if (base.GetFingerprintValue() > 0.75f)
		{
			this.Limb.BreakBone();
		}
		if (base.GetFingerprintValue() > 0.75f)
		{
			this.Limb.Crush();
		}
		if (base.GetFingerprintValue() > 0.85f)
		{
			Limb.BreakingThreshold -= 340282346600000000000000000000000000f;
		}
		skinMaterialHandler.AcidProgress += base.GetFingerprintValue() * 0.1f;
		skinMaterialHandler.intensityMultiplier += base.GetFingerprintValue() * 0.5f;
		if (base.GetFingerprintValue() > 0.9f)
		{
			circulationBehaviour.Cut(this.Limb.transform.position, UnityEngine.Random.insideUnitCircle);
		}
		circulationBehaviour.BleedingRate *= Mathf.Abs(base.GetFingerprintValue());
		circulationBehaviour.BloodLossRateMultiplier += base.GetFingerprintValue() * 0.2f;
		circulationBehaviour.IsPump ^= (base.GetFingerprintValue() > 0.9f);
		circulationBehaviour.WasInitiallyPumping ^= (base.GetFingerprintValue() > 0.7f);
		physicalBehaviour.AbsorbsLasers ^= (base.GetFingerprintValue() > 0f);
		physicalBehaviour.ReflectsLasers ^= (base.GetFingerprintValue() > 0.7f);
		physicalBehaviour.rigidbody.mass += base.GetFingerprintValue() * physicalBehaviour.rigidbody.mass * 0.5f;
		if (base.GetFingerprintValue() > 0.69f)
		{
			physicalBehaviour.Charge += Mathf.Pow(base.GetFingerprintValue() * 25f, 3f);
		}
		if (base.GetFingerprintValue() > 0.55f)
		{
			physicalBehaviour.Ignite(true);
		}
		if (base.GetFingerprintValue() > 0.7f)
		{
			physicalBehaviour.transform.localScale += new Vector3(base.GetFingerprintValue(), base.GetFingerprintValue()) * 0.2f;
		}
		physicalBehaviour.rigidbody.gravityScale += ((base.GetFingerprintValue() > 0.7f) ? base.GetFingerprintValue() : 0f);
		this.Limb.Vitality *= base.GetFingerprintValue() * 8f;
		this.Limb.RegenerationSpeed += base.GetFingerprintValue() * 8f;
		this.Limb.ImpactPainMultiplier += base.GetFingerprintValue();
		this.Limb.InitialHealth += base.GetFingerprintValue();
		this.Limb.Health = this.Limb.InitialHealth;
		this.Limb.BreakingThreshold += base.GetFingerprintValue();
		this.Limb.BaseStrength += base.GetFingerprintValue() * 8f;
		if (base.GetFingerprintValue() > 0.75f)
		{
			//ExplosionCreator.CreateExplosionWithWater(WaterBehaviour.IsPointUnderWater(this.Limb.transform.position), WaterBehaviour.GetWaterLevelOr(float.MinValue), new ExplosionCreator.ExplosionParameters(32U, this.Limb.transform.position, Mathf.Abs(base.GetFingerprintValue()) * 8f, base.GetFingerprintValue() * 25f, base.GetFingerprintValue() < 0.5f, base.GetFingerprintValue() > 0.9f, 0f), true);
		}
		this.Limb.Frozen = (base.GetFingerprintValue() > 0.95f);
		this.Limb.Wince(base.GetFingerprintValue());
	}
}
}