using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Experiment01 {
	public class rainboweffect : MonoBehaviour
{
    public float Speed = 1;
    private SpriteRenderer rend;
 
    void Start()
    {
        rend = GetComponent<SpriteRenderer>();
		rend.sharedMaterial = ModAPI.FindMaterial("VeryBright");
    }
 
    void Update()
    {
        rend.material.SetColor("_Color", HSBColor.ToColor(new HSBColor( Mathf.PingPong(Time.time * Speed, 1), 1, 1)));
    }
}
  class SplitPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 0f;
      }
    }

    public override void Start() {
		Limb.BreakingThreshold -= 99999999999999999999999999f;
			Limb.IsDismembered = true;
    }

    public SplitPoison() {}
  }
  class WeightlessPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		 Limb.gameObject.GetComponent<PhysicalBehaviour>().MakeWeightless();
    }

    public WeightlessPoison() {}
  }
  class LaserReflectionPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		var phys = Limb.gameObject.GetComponent<PhysicalBehaviour>();
		//phys.AbsorbsLasers = false;
		phys.ReflectsLasers = true;
    }

    public LaserReflectionPoison() {}
  }
  class BouncyPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
BoxCollider2D Mat = gameObject.GetComponent<BoxCollider2D>();

			var phys = Limb.gameObject.GetComponent<PhysicalBehaviour>();
			PhysicsMaterial2D material = new PhysicsMaterial2D();
            material.bounciness = 3f;

			Mat.sharedMaterial = material;
    }

    public BouncyPoison() {}
  }
  class SlipperyPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		BoxCollider2D Mat = gameObject.GetComponent<BoxCollider2D>();

			var phys = Limb.gameObject.GetComponent<PhysicalBehaviour>();
			PhysicsMaterial2D material = new PhysicsMaterial2D();
            material.friction = 0.005f;

			Mat.sharedMaterial = material;
    }

    public SlipperyPoison() {}
  }
  public class JumpingPoisonBehaviour : MonoBehaviour
  {
	  void Start()
	  {
		  rb = gameObject.GetComponent<Rigidbody2D>();
		  lb = gameObject.GetComponent<LimbBehaviour>();
		  StartCoroutine(startjumping());
	  }
	  IEnumerator startjumping() {
      while (lb.IsConsideredAlive) {
        yield
        return new WaitForSeconds(1.0f);
        rb.AddForce(transform.up* 50f,ForceMode2D.Impulse);
        yield
        return null;
      }
      }
	  [SkipSerialisation]
	  public LimbBehaviour lb;
	  [SkipSerialisation]
	  public Rigidbody2D rb;
  }
  /*class GorsePoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		if(Limb.gameObject.name == "Head" && InjectorHelpers.PoisonCanInfect(Limb.gameObject,"gorsepoison",true))
		{
			Limb.Person.SetBodyTextures(ModAPI.LoadTexture("gorseskin.png"), null,null, 1);
			GorseDroolingBehaviour gorseai = Limb.gameObject.AddComponent<GorseDroolingBehaviour>() as GorseDroolingBehaviour;
			gorseai.CanSee = LayerMask.NameToLayer("Objects");
			gorseai.LimbBehaviour = Limb;
			gorseai.Projectile = ModAPI.FindSpawnable("Brick").Prefab;
			gorseai.ParticleSystem = Limb.gameObject.AddComponent<ParticleSystem>();
			gorseai.FireClip = new AudioClip[]{ModAPI.LoadSound("bonebreak3.wav")};
			gorseai.Range = 12f;
			gorseai.Force = 1f;
		}
    }

    public GorsePoison() {}
  }*/
  class KillerBehaviour : MonoBehaviour
  {
	  private void Start() {
	    if (this.Fingerprint == null || this.Fingerprint.Length == 0) {
	      this.CreateNewFingerprint();
	    }
	  }
	  private void CreateNewFingerprint() {
	    this.Fingerprint = new float[64];
	    for (int i = 0; i < this.Fingerprint.Length; i++) {
	      this.Fingerprint[i] = UnityEngine.Random.Range(-1f, 1f);
	    }
	    Debug.Log(string.Format("ATKILLER-Fingerprints ({0}) filled", this.Fingerprint.Length));
	  }
	  void OnCollisionEnter2D(Collision2D col)
	{
		LimbBehaviour DetectedLimb = col.gameObject.GetComponent<LimbBehaviour>();
		if(DetectedLimb)
		{
			if(DetectedLimb.IsConsideredAlive)
			{
				if (!DetectedLimb.gameObject.GetComponent(typeof(AcidPoison))) {
				PoisonSpreadBehaviour poisonSpreadBehaviour = DetectedLimb.gameObject.AddComponent(typeof(AcidPoison)) as PoisonSpreadBehaviour;
	            poisonSpreadBehaviour.Limb = DetectedLimb;
				poisonSpreadBehaviour.Fingerprint = this.Fingerprint;
				}
			}
		}
	}
	public float[] Fingerprint;
  }
  class KillerPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		if(InjectorHelpers.PoisonCanInfect(Limb.gameObject,"killerpoison",true))
		{
			var renderer = Limb.gameObject.GetComponent<SpriteRenderer>();
			renderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
			renderer.color = new Color32(255,0,0,255);
			Limb.gameObject.AddComponent<KillerBehaviour>();
		}
    }

    public KillerPoison() {}
  }
  public class MinorMalfunctionBehaviour : MonoBehaviour
  {
	  void Start()
	  {
		  rand = new System.Random((int)seed);
		  setvoltage = rand.Next(1,10);// voltage min max
		  timer = rand.Next(2,6); //timer min max
		  phys = gameObject.GetComponent<PhysicalBehaviour>();
		  StartCoroutine(StartTimer());
	  }
	  void FixedUpdate()
	  {
		  if (timer > 0)
		  {
		  phys.Charge = setvoltage;
		  }
		  else
		  {
			  UnityEngine.Object.Destroy(this);
		  }
	  }
	  IEnumerator StartTimer() {
      while (timer > 0) {
        yield
        return new WaitForSeconds(1.0f);
		timer -= 1;
        yield
        return null;
      }
      }
	  public PhysicalBehaviour phys;
	  public float seed;
	  private System.Random rand;
      public int setvoltage;
	  public int timer = 5;
  }
  class M_Malfunction_Injector : PoisonSpreadBehaviour
  {
	 public override float SpreadSpeed {
      get {
        return 2f;
      }
    }

    public override void Start() {
		var rand = new System.Random();
		if(rand.Next(1,3) == 2)
		{
			float seed = base.GetFingerprintValue();
			Limb.gameObject.AddComponent<MinorMalfunctionBehaviour>().seed = seed;
		}
    }

    public M_Malfunction_Injector() {} 
  }
  class RainbowPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 15f;
      }
    }

    public override void Start() {
		if(InjectorHelpers.PoisonCanInfect(Limb.gameObject,"rainbowpoison",true))
		{
			Limb.gameObject.AddComponent<rainboweffect>();
		}
    }

    public RainbowPoison() {}
  }
  class TanglingPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 2f;
      }
    }

    public override void Start() {
		Transform[] childs = (Transform[]) Limb.gameObject.transform.parent.gameObject.GetComponentsInChildren<Transform>();
        GameObject rr = (GameObject) ((Transform)childs[UnityEngine.Random.Range(0,childs.Length)]).gameObject;
		if(rr.GetComponent<LimbBehaviour>() != null)
		{
		InjectorHelpers.CreateRope(gameObject,rr,new Color32(0,255,0,255),1f);
		}
    }

    public TanglingPoison() {}
  }
class DwarfingPoison: PoisonSpreadBehaviour {

    public override float SpreadSpeed {
      get {
        return 50f;
      }
    }

    public override void Start() {
      if (Limb.gameObject.name == "Head") {
        //Limb.gameObject.transform.parent.localScale *= 1.25f;
        Limb.gameObject.transform.parent.gameObject.AddComponent < SmoothGrowth > ().ScaleStart(1f,0.5f);
      }
    }

    public DwarfingPoison() {}
  }
  class DwarfInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (DwarfingPoison);
    }
  }
  class MMInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (M_Malfunction_Injector);
    }
  }
  class RainbowInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (RainbowPoison);
    }
  }
  class SplitInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (SplitPoison);
    }
  }
  class WeightlessInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (WeightlessPoison);
    }
  }
  class ReflectInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (LaserReflectionPoison);
    }
  }
  class BouncyInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (BouncyPoison);
    }
  }
  class TanglingInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (TanglingPoison);
    }
  }
  class SlipperyInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (SlipperyPoison);
    }
  }
  class DeathInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (DeathPoison);
    }
  }
  /*class GorseInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (GorsePoison);
    }
  }*/
  class KillerInjector: AndroidInjectorBase {
    public override Type GetPoisonType() {
      return typeof (KillerPoison);
    }
  }
}